#ifndef lint
static char *RCSid = "$Header: path.c,v 1.12 89/09/02 02:36:16 mr-frog Exp $";
#endif

/*
 * path.c
 *
 * Show empire distribution paths.
 *
 * David Muir Sharnoff, 1986
 * Re-written 1989
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"
#include "sect.h"
#include "path.h"
#include "map.h"

int
path()
{
	extern	char *argp[];

	struct	nstr_sect ns;
	struct	natstr	*natp;
	struct	range	absrange;
	struct	range	relrange;
	struct	sctstr	sect;
	coord	cx, cy;
	int     i;
	int	y;
	char    *pp;
	char	*p;
	char	map[WORLD_Y][MAPWIDTH(3)];

	if (!(p = getstarg(argp[1], "from sector : ")) ||
	    !sarg_xy(p, &cx, &cy) ||
	    !getsect(cx, cy, &sect))
		return RET_SYN;
	if (sect.sct_own != cnum) {
		pr("Not yours\n");
		return RET_FAIL;
	}
	pp = masktopath(sect.sct_distpath);
	pathrange(cx, cy, pp, 1, &absrange);
	snxtsct_area(&ns, &absrange);
	natp = getnatp(cnum);
	xyrelrange(natp, &absrange, &relrange);
	blankfill((char *)map, &ns.range, 3);
	while (*pp && (i = chkdir(*pp, DIR_STOP, DIR_LAST)) >= 0) {
		bcopy(routech[i][0], &map[deltay(cy, ns.range.ly)]
					 [deltax(cx, ns.range.lx)*2], 3);
		cx += diroff[i][0];
		cy += diroff[i][1];
		++pp;
	}
	border(&relrange, "     ", " ");
	while (nxtsct(&ns, &sect)) {
		if (!owner)
			continue;
		map[ns.dy][ns.dx*2+1] = dchr[sect.sct_type].d_mnem;
	}
	for (y=ns.range.ly, i=0; i < ns.range.height; y++, i++) {
		cy = yrel(natp, y);
		pr(fmt("%4d %s %-4d\n", cy, map[i], cy));
		if (y >= WORLD_Y)
			y -= WORLD_Y;
	}
	border(&relrange, "     ", " ");
	return RET_OK;
}
